LogoopenSUSE Build Service > Projects
Sign Up | Log In

View File openssl-CVE-2006-2937.patch of Package compat-openssl097g (Project openSUSE:11.4)

Dr S N Henson of the OpenSSL core team and Open Network Security
recently developed an ASN1 test suite for NISCC (www.niscc.gov.uk). When
the test suite was run against OpenSSL two denial of service
vulnerabilities were discovered.

During the parsing of certain invalid ASN1 structures an error
condition is mishandled. This can result in an infinite loop which
consumes system memory.  CVE-2006-2938

Any code which uses OpenSSL to parse ASN1 data from untrusted sources is
affected. This includes SSL servers which enable client authentication
and S/MIME applications.

This issue affects 0.9.7 and 0.9.8 but not 0.9.6 and earlier

diff -ur -x CVS openssl8/crypto/asn1/tasn_dec.c ossl8/crypto/asn1/tasn_dec.c
--- crypto/asn1/tasn_dec.c     2006-08-31 21:08:20.000000000 +0100
+++ crypto/asn1/tasn_dec.c        2006-08-31 21:38:19.000000000 +0100
@@ -628,6 +628,7 @@
 		ASN1err(ASN1_F_ASN1_D2I_EX_PRIMITIVE, ERR_R_NESTED_ASN1_ERROR);
 		return 0;
 	} else if(ret == -1) return -1;
+	ret = 0;
 	/* SEQUENCE, SET and "OTHER" are left in encoded form */
 	if((utype == V_ASN1_SEQUENCE) || (utype == V_ASN1_SET) || (utype == V_ASN1_OTHER)) {
 		/* Clear context cache for type OTHER because the auto clear when